'''A Basicaly Utility/Admin Script
    By: J3ff Hoogland'''

import es, gamethread, popuplib, keyvalues, time, effectlib, beaconlib, votelib, os, string, random
from beaconlib import *
#Add Info
info = es.AddonInfo()
info.name = 'J3ff\'s Admin'
info.version = '1.01'
info.url = 'http://addons.eventscripts.com/addons/view/j3ffadmin'
info.basename = 'j3ffadmin'
info.author = 'J3ff Hoogland'
es.ServerVar('ja_version',info.version,'JAdmin By: J3ff Hoogland').makepublic()

#Global Vars
Admins = {}
Adverts = []
RTV_Votes = 0.0
RTV_List = []
CVars = {'sv':[],
        'mp':[],
        'es':[],
        'other':[]}
ServerVars = {'Advert_Timer':20,
                'RTV_Percent':60,
                'RTV_Maps':4}
Delay_List = ['j3ff adverts']
Commands = ['ja_makeadmin',
        'ja_var',
        'ja_rcon',
        'ja_changemap',
        'ja_setmap',
        'ja_addflags',
        'ja_removeflags',
        'ja_removeadmin',
        'ja_kick',
        'ja_ban',
        'ja_parsefiles',
        'ja_addcomment',
        'ja_beacon',
        'ja_slay']
ChatCommands = ['timeleft',
                'nextmap',
                'rockthevote',
                'rtv',
                'ff',
                'friendlyfire',
                'themap',
                'currentmap']
gamedir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
AddonPath = es.getAddonPath('j3ffadmin')

#Global Methods
def load():
    for Var in ServerVars:
        es.ServerVar(Var).set(ServerVars[Var])
    for command in Commands:
        if not es.exists('command', command):
            es.regcmd(command, 'j3ffadmin/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'j3ffadmin/%s_client'%command)
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'j3ffadmin/%s_client'%command)
    for command in ChatCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'j3ffadmin/%s'%command)
    if not es.exists('clientcommand', 'admin'):
        es.regclientcmd('admin', 'j3ffadmin/admin')
    if not es.exists('saycommand', 'admin'):
        es.regsaycmd('admin', 'j3ffadmin/admin')
    if not es.exists('saycommand', '@'):
        es.regsaycmd('@', 'j3ffadmin/adminchat')
    global TimeStart
    TimeStart = int(time.time())
    ja_parsefiles()
    Advert_Loop()
    BuildMenus()

def unload():
    for delay in Delay_List:
        gamethread.cancelDelayed(delay)

def es_map_start(ev):
    global TimeStart
    TimeStart = int(time.time())
    global RTV_Votes
    RTV_Votes = 0.0
    global RTV_List
    RTV_List = []

def player_disconnect(ev):
    userid = int(ev['userid'])
    if userid in RTV_List:
        RTV_List.remove(userid)
        global RTV_Votes
        RTV_Votes -= 1.0

def Advert_Loop(Count=0):
    if len(Adverts):
        es.msg('#multi', Adverts[Count])
    Count += 1
    if Count >= len(Adverts):
        Count = 0
    gamethread.delayedname(int(es.ServerVar('Advert_Timer')), 'j3ff adverts', Advert_Loop, Count)

def __ParseFiles():
    global Adverts
    Adverts = []
    global CVars
    CVars = {'sv':[],
        'mp':[],
        'es':[],
        'other':[]}
    advert_file = open(AddonPath+'/adverts.txt')
    for line in advert_file:
        Adverts.append(line.replace('\n', ''))
    advert_file.close()
    cvar_file = open(AddonPath+'/cvarcontrol.txt')
    for line in cvar_file:
        if not line.startswith('//') and line:
            if 'sv_' in line:
                CVars['sv'].append(line.replace('\n', ''))
            elif 'mp_' in line:
                CVars['mp'].append(line.replace('\n', ''))
            elif 'eventscripts' in line:
                CVars['es'].append(line.replace('\n', ''))
            else:
                CVars['other'].append(line.replace('\n', ''))
    cvar_file.close()
    jadmins = keyvalues.getKeyGroup('jadmins')
    for steamid in jadmins:
        if steamid.getName() not in Admins:
            Admins[steamid.getName()] = []
        for key in jadmins[steamid.getName()]:
            if jadmins[steamid.getName()][key.getName()] == 'flag':
                Admins[steamid.getName()].append(key.getName())

def hasFlag(userid, flag):
    steamid = es.getplayersteamid(userid)
    if steamid in Admins:
        if flag in Admins[steamid] or 'full' in Admins[steamid]:
            return 1
        else:
            return 0
    else:
        return 0

def logAction(userid, command, comments=['n/a']):
    steamid = es.getplayersteamid(userid)
    if steamid != 'STEAM_ID_LAN':
        adminfile = open(AddonPath+'/logs/%s_log.txt'%steamid.split(':')[2], 'a')
    else:
        adminfile = open(AddonPath+'/logs/LAN_log.txt', 'a')
    adminfile.write('Admin - %s\n'%es.getplayername(userid))
    adminfile.write('Date - %s'%time.strftime('%x %X\n'))
    adminfile.write(' Command: %s\n'%command)
    adminfile.write(' - Comments -\n')
    for comment in comments:
        adminfile.write('  %s\n'%comment)
    adminfile.write('\n\n')
    adminfile.close()

#Core admin command handels
def admin(userid=""):
    if not userid:
        userid = es.getcmduserid()
    if es.getplayersteamid(userid) in Admins:
        amenu = popuplib.create('admin menu')
        amenu.addline('Admin Menu')
        amenu.addline('-> 1. Player Management')
        amenu.addline('-> 2. Map Management')
        if hasFlag(userid, 'var'):
            amenu.addline('-> 3. Adjust Server Vars')
        amenu.addline('0. Exit')
        amenu.menuselect = adminmainselect
        amenu.send(userid)
    else:
        es.tell(userid, '#multi', '#lightgreenYou are not an admin.')

def adminmainselect(userid, choice, popupid):
    if choice == 1:
        playermanagement(userid)
    elif choice == 2:
        mapmanagement(userid)
    elif choice == 3 and hasFlag(userid, 'var'):
        varmenu.send(userid)

def playermanagement(userid):
    amenu = popuplib.easymenu('easymenu', None, adminselect)
    amenu.settitle("Player Management Menu")
    if hasFlag(userid, 'kick'):
        amenu.addoption('kick', 'Kick a Player')
    if hasFlag(userid, 'ban'):
        amenu.addoption('ban', 'Ban a Player')
    if hasFlag(userid, 'slay'):
        amenu.addoption('slay', 'Slay a Player')
    if hasFlag(userid, 'beacon'):
        amenu.addoption('beacon', 'Beacon a Player')
    amenu.addoption('back', 'To Main Menu')
    amenu.send(userid)
    
def mapmanagement(userid):
    amenu = popuplib.easymenu('easymenu', None, adminselect)
    amenu.settitle("Map Management Menu")
    if hasFlag(userid, 'mapset'):
        amenu.addoption('mapset', 'Set Next Map')
    if hasFlag(userid, 'mapchange'):
        amenu.addoption('mapchange', 'Change Current Map')
    if hasFlag(userid, 'mapvote'):
        amenu.addoption('mapvote', 'Start a Map Vote')
    amenu.addoption('back', 'To Main Menu')
    amenu.send(userid)

def adminselect(userid, choice, popupid):
    if choice == 'back':
        admin(userid)
    elif choice == 'mapset':
        mapmenu(userid, 'set')
    elif choice == 'mapchange':
        mapmenu(userid, 'change')
    elif choice == 'mapvote':
        ja_mapvote()
    elif choice == 'kick':
        playermenu(userid, 'ja_kick')
    elif choice == 'ban':
        playermenu(userid, 'ja_ban')
    elif choice == 'slay':
        playermenu(userid, 'ja_slay', 1)
    elif choice == 'beacon':
        playermenu(userid, 'ja_beacon', 1)

def mapmenu(userid, kind):
    maps = open('%s/maplist.txt'%gamedir)
    mapmenu = popuplib.easymenu('map menu', None, mapselect)
    if kind == 'set':
        mapmenu.settitle('Set the next map to:')
    elif kind == 'change':
        mapmenu.settitle('Change map to:')
    counter = 0
    for map in maps:
        counter += 1
        mapmenu.addoption((kind, map), map)
        if counter == 6:
            mapmenu.addoption('back', 'Back')
    if counter < 6:
        mapmenu.addoption('back', 'Back')
    mapmenu.send(userid)

def mapselect(userid, choice, popupid):
    if choice == 'back':
        admin(userid)
    elif choice[0] == 'set':
        es.cexec(userid, 'ja_setmap %s'%choice[1])
    elif choice[0] == 'change':
        es.cexec(userid, 'ja_changemap %s'%choice[1])

def playermenu(userid, kind, alive=0):
    players = es.getUseridList()
    playermenu = popuplib.easymenu('player menu', None, playerselect)
    playermenu.settitle('Select a Player to %s:'%kind)
    counter = 0
    for player in players:
        add = 1
        if alive:
            if int(es.getplayerprop(player, "CBasePlayer.pl.deadflag")):
                add = 0
        if add:
            counter += 1
            playermenu.addoption((kind, player), es.getplayername(player))
            if counter == 6:
                playermenu.addoption('back', 'Back')
    if counter < 6:
        playermenu.addoption('back', 'Back')
    playermenu.send(userid)

def playerselect(userid, choice, popupid):
    if choice == 'back':
        admin(userid)
    else:
        es.cexec(userid, '%s %s'%(choice[0],choice[1]))

def adminchat():
    userid = es.getcmduserid()
    if hasFlag(userid, 'chat'):
        es.msg('#multi', '#lightgreen-{ Admin %s }- #green: #default%s'%(es.getplayername(userid), es.getargs()))

#Chat Commands for players
def themap():
    currentmap(es.getcmduserid())

def currentmap(userid=""):
    if not userid:
        userid = es.getcmduserid()
    es.tell(userid, '#multi', '#defaultThe current map is #green%s'%es.ServerVar('eventscripts_currentmap'))

def rtv():
    rockthevote(es.getcmduserid())

def rockthevote(userid=""):
    if not userid:
        userid = es.getcmduserid()
    if userid not in RTV_List:
        global RTV_Votes
        RTV_List.append(userid)
        RTV_Votes += 1.0
        if RTV_Votes == 1.0:
            es.msg('#multi', '#green%s #defaulthas started a rock the vote, type #lightgreenrtv #defaultto join in.'%es.getplayername(userid))
            #else:
            es.msg('#multi', '#green%s #defaulthas joined in the rock the vote.'%es.getplayername(userid))
            es.msg('#multi', '#greenRock the Vote #defaultcurrently has #lightgreen%s #defaultout of the #lightgreen%s #defaultvotes needed.'%(RTV_Votes, int(len(es.getUseridList())*(int(es.ServerVar('RTV_Percent'))*.01))))
        es.msg('Percent Votes - %s Needed Percent - %s'%(int((RTV_Votes/len(es.getUseridList()))*100), int(es.ServerVar('RTV_Percent'))))
        if int((RTV_Votes/len(es.getUseridList()))*100) >= int(es.ServerVar('RTV_Percent')):
            ja_mapvote()
    else:
        es.tell(userid, '#multi', '#lightgreenYou have already entered the Rock the Vote.')

def ff():
    friendlyfire(es.getcmduserid())

def friendlyfire(userid=""):
    if not userid:
        userid = es.getcmduserid()
    if int(es.ServerVar('mp_friendlyfire')):
        es.tell(userid, '#multi', '#defaultFriendly Fire is #lightgreenOn')
    else:
        es.tell(userid, '#multi', '#defaultFriendly Fire is #lightgreenOff')

def timeleft():
    SecondsRemaining = (int(es.ServerVar('mp_timelimit'))*60) - (int(time.time())-TimeStart)
    MinsRemaining = 0
    while SecondsRemaining >= 60:
        SecondsRemaining -= 60
        MinsRemaining += 1
    es.tell(es.getcmduserid(), '#multi', '#defaultThe time remaining is #lightgreen%s minets #defaultand #lightgreen%s seconds#default.'%(MinsRemaining, SecondsRemaining))

def nextmap():
    if str(es.ServerVar('eventscripts_nextmapoverride')):
        map = es.ServerVar('eventscripts_nextmapoverride')
    else:
        map = getNextMap()
    es.tell(es.getcmduserid(), '#multi', '#defaultThe next map is #green%s'%map)

#Commands
def ja_mapvote_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'mapvote'):
        logAction(userid, 'ja_mapvote', ['Map Vote Started'])
        ja_mapvote()
def ja_mapvote():
    rtv = votelib.create('rock the vote', rtv_finish, rtv_submit)
    rtv.setquestion('Vote for the next Map:')
    maps = open('%s/maplist.txt'%gamedir)
    mymaps = []
    for map in maps:
        mymaps.append(map)
    count = 0
    while count < int(es.ServerVar('RTV_Maps')) and len(mymaps):
        randmap = random.choice(mymaps)
        mymaps.remove(randmap)
        rtv.addoption(randmap)
        count += 1
    rtv.start(60)
    for id in es.getUseridList():
        es.centertell(id, 'A Map Vote has Started - Vote for the Next Map')

def rtv_submit(userid, votename, choice, choicename):
    es.msg('#multi', '#green%s #defaulthas voted for map: #lightgreen%s'%(es.getplayername(userid), choicename))

def rtv_finish(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
    if not tie and not cancelled:
        for userid in es.getUseridList():
            es.tell(userid, '#multi', '#green%s #default has won the map vote with a #green%s #defaultvote percentage.'%(winname, winpercent))
            es.tell(userid, '#multi', '#lightgreenChanging Map In:')
            es.tell(userid, '#multi', '#default ----- 5')
            gamethread.delayed(1, es.tell, (userid, '#multi', '#default ---- 4'))
            gamethread.delayed(2, es.tell, (userid, '#multi', '#default --- 3'))
            gamethread.delayed(3, es.tell, (userid, '#multi', '#default -- 2'))
            gamethread.delayed(4, es.tell, (userid, '#multi', '#default - 1'))
        gamethread.delayed(5, ja_changemap, (winname.strip(), 0))
    elif tie:
        es.msg('#multi', '#defaulThe map vote was a tie... #greenNew Vote!')
        ja_mapvote()

def ja_beacon_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'beacon'):
        ja_beacon(es.getuserid(es.getargv(1)), userid)
def ja_beacon(target="",userid=""):
    if target:
        target = es.getuserid(es.getargv(1))
    target = str(target)
    #es.msg('Running Beacon Method')
    #es.msg(beaconlib.beacon_users)
    if target not in beaconlib.beacon_users:
        beaconlib.EasyBeacon(target).Start()
        if userid:
            logAction(userid, 'ja_beacon', ['Player Beaconed - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target))])
    else:
        beaconlib.EasyBeacon(target).Stop(True)
        if userid:
            logAction(userid, 'ja_beacon', ['Player UnBeaconed - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target))])

def ja_parsefiles_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        logAction(userid, 'ja_parsefiles')
        ja_parsefiles()
def ja_parsefiles():
    global Admins
    Admins = {}
    if es.exists('keygroup', 'jadmins'):
        es.keygroupdelete('jadmins')
    es.keygroupload('jadmins', '|j3ffadmin')
    es.server.queuecmd('exec j3ffconfig.cfg')
    gamethread.delayed(.1, __ParseFiles)

#Slay base taken from jinty|jS, re-written for  JAdmin
def ja_slay_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'slay'):
        target = es.getuserid(es.getargv(1))
        logAction(userid, 'ja_slay', ['Player Slayed - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target))])
        ja_slay(target)
def ja_slay(target=""):
    if not target:
        target = es.getuserid(es.getargv(1))
    es.emitsound('player', target, '../sound/ambient/thunder2.wav', '1.0', '0.7')
    x,y,z = es.getplayerlocation(target)
    effectlib.drawLine((x,y,z+5000), (x,y,z), model='materials/sprites/lgtning_noz.vmt', halo="materials/sprites/ligh_glow02_noz.vmt", seconds=0.2, width=3, endwidth=0.1, speed=100) 
    es.effect('sparks', '%s,%s,%s'%(x,y,z), 100, 100, '0,0,0')
    es.server.queuecmd('damage %s %s 64'%(target, int(es.getplayerprop(target, "CBasePlayer.m_iHealth"))*10))

def ja_kick_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'kick'):
        target = es.getuserid(es.getargv(1))
        logAction(userid, 'ja_kick', ['Player Kicked - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target))])
        ja_kick(target)
def ja_kick(target=""):
    if not target:
        target = es.getuserid(es.getargv(1))
    es.server.queuecmd('kickid %s'%target)

def ja_ban_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'ban'):
        target = es.getuserid(es.getargv(1))
        duration = int(es.getargv(2))
        logAction(userid, 'ja_ban', ['Player Banned - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target)), 'Duration - %s (0 = Forever)'%duration])
        ja_ban(target, duration)
def ja_ban(target="",duration=0):
    if not target:
        target = es.getuserid(es.getargv(1))
        duration = int(es.getargv(2))
    es.server.queuecmd('banid %s %s kick'%(duration, target))

def ja_rcon_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        logAction(userid, 'ja_rcon', ['Command and Args Fired : %s'%es.getargs()])
        ja_rcon(es.getargs())
def ja_rcon(args=""):
    if not args:
        args = es.getargs()
    es.server.queuecmd(args)

def ja_makeadmin_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
        ja_makeadmin(steamid,str(es.getargv(2)).split(','),str(es.getargv(3)).split(','))
        logAction(userid, 'ja_makeadmin', ['Steamid Made Admin: %s'%steamid, 'Flags Given: %s'%es.getargv(2), 'Comments Made: %s'%es.getargv(3)])
def ja_makeadmin(steamid="",flags=[],comments=[]):
    if not steamid:
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
    if not flags:
        flags = str(es.getargv(2)).split(',')
    if not comments:
        comments = str(es.getargv(3)).split(',')
    if not flags:
        flags = ['full']
    if es.exists('key', 'jadmins', steamid):
        es.keydelete('jadmins', steamid)
    es.keycreate('jadmins', steamid)
    Admins[steamid] = []
    for flag in flags:
        es.keysetvalue('jadmins', steamid, flag, 'flag')
        Admins[steamid].append(flag)
    for comment in comments:
        es.keysetvalue('jadmins', steamid, comment, 'comment')
    es.keygroupsave('jadmins', '|j3ffadmin')

def ja_removeadmin_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
        logAction(userid, 'ja_removeadmin', ['Steamid Removed: %s'%steamid])
        ja_removeadmin(steamid)
def ja_removeadmin(steamid=""):
    if not steamid:
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
    if steamid in Admins:
        if 'full' not in Admins[steamid]:
            del Admins[steamid]
            es.keydelete('jadmins', steamid)
            es.keygroupsave('jadmins', '|j3ffadmin')

def ja_addflags_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
        logAction(userid, 'ja_addflags', ['Steamid Edited: %s'%steamid, 'Flags Added: %s'%es.getargv(2)])
        ja_addflags(steamid, str(es.getargv(2)).split(','))
def ja_addflags(steamid="",flags=[]):
    if not steamid:
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
    if not flags:
        flags = str(es.getargv(2)).split(',')
    if steamid in Admins:
        for flag in flags:
            Admins[steamid].append(flag)
            es.keysetvalue('jadmins', steamid, flag, 'flag')
        es.keygroupsave('jadmins', '|j3ffadmin')
    else:
        ja_makeadmin(steamid, flags)

def ja_removeflags_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
        logAction(userid, 'ja_addflags', ['Steamid Edited: %s'%steamid, 'Flags Added: %s'%es.getargv(2)])
        ja_removeflags(steamid, str(es.getargv(2)).split(','))
def ja_removeflags(steamid="",flags=[]):
    if not steamid:
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
    if not flags:
        flags = str(es.getargv(2)).split(',')
    if steamid in Admins:
        for flag in flags:
            if hasFlag(steamid, flag) and 'full' not in Admins[steamid]:
                es.keysetvalue('jadmins', steamid, flag, 'removed')
                Admins[steamid].remove(flag)
        es.keygroupsave('jadmins', '|j3ffadmin')

def ja_addcomment_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'full'):
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
        logAction(userid, 'ja_addcomment', ['Steamid Edited: %s'%steamid, 'Comments Added: %s'%es.getargv(2)])
        ja_addcomment(steamid, str(es.getargv(2)).split(','))
def ja_addcomment(steamid="",comments=[]):
    if not steamid:
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
    if not comments:
        comments = str(es.getargv(2)).split(',')
    if steamid in Admins:
        for comment in comments:
            es.keysetvalue('jadmins', steamid, comment, 'comment')
        es.keygroupsave('jadmins', '|j3ffadmin')

def ja_var_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'var'):
        logAction(userid, 'ja_var', ['Var Changed - %s'%es.getargv(1), 'New Value - %s'%es.getargv(2)])
        ja_var(es.getargv(1), es.getargv(2))
def ja_var(var="",value=""):
    if not var:
        var = es.getargv(1)
    if not value:
        value = es.getargv(2)
    es.ServerVar(var).set(value)

def ja_changemap_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'mapchange'):
        map = es.getargv(1)
        es.msg('#multi', '#lightgreen-{ Admin %s }- #default is changing the map to: #green%s'%(es.getplayername(userid), map))
        logAction(userid, 'ja_changemap', ['Map Changed To - %s'%map])
        ja_changemap(map)
def ja_changemap(map="",delay=2):
    if not map:
        map = str(es.getargv(1))
        es.msg('#multi', '#lightgreenThe is changing the map to: #green%s'%(map))
    if es.exists('map', map):
        gamethread.delayed(delay, es.server.queuecmd, ('changelevel %s'%map))

def ja_setmap_client():
    userid = es.getcmduserid()
    if hasFlag(userid, 'mapset'):
        map = es.getargv(1)
        ja_setmap(map)
        es.msg('#multi', '#lightgreen-{ Admin %s }- #defaulthas set the next map to: #green%s'%(es.getplayername(userid), map))
        logAction(userid, 'ja_changemap', ['Next Map Set To - %s'%map])
def ja_setmap(map=""):
    if not map:
        map = str(es.getargv(1))
        es.msg('#multi', '#lightgreenThe next map has been set to: #green%s'%(map))
    if es.exists('map', map):
        es.ServerVar('eventscripts_nextmapoverride').set(map)

#Builds all static menus for the mod
def BuildMenus():
    global varmenu
    varmenu = popuplib.create('varmenu')
    varmenu.addline("What Type of Server_Var would you like to Change:")
    varmenu.addline("-> 1. sv_ CVars")
    varmenu.addline("-> 2. mp_ CVars")
    varmenu.addline("-> 3. Event Scripts CVars")
    varmenu.addline("-> 4. Misc. Server Vars")
    varmenu.addline("-> 9. Back")
    varmenu.addline("0. Exit")
    varmenu.menuselect = VarMenuSelect

#Our Menu Select Handels
def VarMenuSelect(userid, choice, popupid):
    mymenu = popuplib.easymenu('x menu', None, VarSelected)
    mymenu.settitle('Select a var to edit the value of:')
    counter = 0
    if choice == 1:
        for Var in CVars['sv']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 6:
                mymenu.addoption('back', 'Back')
    elif choice == 2:
        for Var in CVars['mp']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 6:
                mymenu.addoption('back', 'Back')
    elif choice == 3:
        for Var in CVars['es']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 6:
                mymenu.addoption('back', 'Back')
    elif choice == 4:
        for Var in CVars['other']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 6:
                mymenu.addoption('back', 'Back')
    elif choice >= 5 and choice <= 8:
        varmenu.send(userid)
    elif choice == 9:
        admin(userid)
    if choice <= 4:
        if counter < 6:
            mymenu.addoption('back', 'Back')
        mymenu.send(userid)

def VarSelected(userid, Var, popupid):
    if Var == 'back':
        varmenu.send(userid)
    else:
        es.escinputbox(10, userid, 'J3ff Admin - Change Variable', 'Set the value of %s to'%Var, 'ja_var %s'%Var)

#Next map function provided by: Nicolous        
def getNextMap():
    """
        Return a VALID nextmap name
        Throw an AutoMapChangeException exception if no valid name can be found
    """

    nextmap = None # Will contains the name of the nextmap
    convar_currentmap = es.ServerVar('eventscripts_currentmap')
    pathFile = "%s/%s/mapcycle.txt" % (os.getcwd(),gamedir)
# FYI : convar_mapcyle contains the name of the mapcycle file

    if os.path.isfile(pathFile): # Is the mapcycle file exists ?
        firstMap = None # Will contains the name of the first map name in the mapcycle file
                 # in case of the mapcycle is finished

        # Parsing file...
        mapcycle = None
        try:
            mapcycle = open(pathFile,"r")
            line = mapcycle.readline()
            while line != "":
                theMap = line.replace("\n","")

                if firstMap is None: # FIXME : this test should not be in the loop
                    firstMap = theMap

                # Is the current map found ?
                if theMap == str(convar_currentmap):
                    # Yes, is there a next line ? (our nextmap)
                    theMap = mapcycle.readline().replace("\n","")
                    if theMap != "":
                        # Yes, we found the nextmap
                        nextmap = theMap
                    line = "" # <=> break
                # No Sad Continue...
                else:
                    line = mapcycle.readline()
        except IOError:
            pass
# FYI : i18n = langlib.Strings("%s/strings.ini" % es.getAddonPath(info.name))
        finally: # Error or not, we must close the file
            if mapcycle != None:
                mapcycle.close()

        # If no map has been found, the mapcycle is finished
        if nextmap == None:
            nextmap = firstMap # Restart the mapcycle to the first map

    # Is the nextmap valid ?
    if nextmap is not None:
        # Be sure this map exists !
        if es.exists("map",nextmap):
            return nextmap
    else:
        return 'Unknown'
